=== debian/changelog ===
geonkick (3.5.2-0ubuntu1) plucky; urgency=medium

  * New upstreeam release.
  * d/copyright: bump dates
  * d/control: pkg-config -> pkgconf

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 18 Feb 2025 13:09:43 -0800
