=== debian/control ===
Source: geonkick
Section: sound
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
XSBC-Original-Maintainer: Equipe LibraZiK <librazik@tuxfamily.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libcairo2-dev,
 libjack-jackd2-dev | libjack-dev,
 libx11-dev,
 lv2-dev,
 pkgconf,
 rapidjson-dev,
 libsndfile1-dev,
 libssl-dev
Standards-Version: 4.6.1
Homepage: https://github.com/iurie-sw/geonkick

Package: geonkick
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Provides: standalone-plugin, lv2-plugin
Description: Kick drum synthesizer
 Geonkick is a synthesizer that can synthesize elements of percussion. The most
 basic examples are: kick drums, snares, hit-hats, shakers, claps, steaks.
 .
 Available as an LV2 plugin and JACK standalone version.
